(* 03:40 Dec 16, 2012 wzh *)

type unop = Neg | Not | Atx | Aty | Atr | Atg | Atb | Atk				(* Unary operators *)

type binop = Add | Sub | Mul | Div | Mod | Gt | Lt | Geq | Leq | Eq | Neq | And | Or	(* Binary Operators*)

type t =
  Void_T
| Int_T
| Char_T
| Float_T
| String_T
| Boolean_T
| Point_T
| Color_T
| Key_T

type constant =		(* Basic data types*)
  Integer of int		(* 823 *)
| Char of char 		(* 'H' *)
| Float of float		(* 3.14159265358 *)
| String of string		(* "Jinqi Huang" *)
| Boolean of bool		(* true false *)
| Point of int * int		(* {12,123} *)
| Color of int * int * int	(* #122,32,254# *)
| Key of string		(* $Space$ *)
